Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 3.2.0   

Resolution: Fixed Affected version:  

Description

Currently the done ratio of parent issues in an issue tree is calculated based on the average of done ratios of the leaves bellow that

issue source:/tags/3.1.1/app/models/issue.rb#L1491. This however can lead to inconsistencies in the automatically calculated done

ratios.

For example: issue C with a done ratio of 50% and an open status, which is a subtask of issue B with a done ratio of 70%

automatically set by its (open) status, which itself is a subtask of issue A, with a status that doesn't automatically set the done ratio. In

that case, A will have an automatically calculated done ratio of 50% because it will be calculated based on the leaf's done ratios, i.e.

from C, although its only direct child has a done ratio of 70%.

Is there any rationale to keeping the calculation of the done ratio based on the leaves? I would like to change it to be calculated

based on the done ratios of the direct children. If this is an acceptable change I can work on a patch.

Related issues:

Related to Redmine - Defect #23511: Progress of parent task should be calcula... Closed

Associated revisions

Revision 14875 - 2015-11-14 10:58 - Jean-Philippe Lang

Calculate done_ratio based on children instead of leaves (#20995).

Patch by Jens Krämer.

History

#1 - 2015-10-15 09:35 - Felix Schäfer

As a side-note: I'm aware of #6609, this is not directly related though.

#2 - 2015-10-21 10:19 - Jens Krämer

- File calculate_done_ratio_from_children_20995.diff added

here's a patch switching done ratio calculation from the leaves to direct children, and a test illustrating the problem.

#3 - 2015-11-13 12:13 - Toshi MARUYAMA

- Target version set to 3.2.0

#4 - 2015-11-14 10:59 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

#5 - 2016-08-23 15:24 - Toshi MARUYAMA

- Related to Defect #23511: Progress of parent task should be calculated using total estimated hours of children added

Files

calculate_done_ratio_from_children_20995.diff 2.31 KB 2015-10-21 Jens Krämer
